using System;
using System.Drawing;
using System.Windows.Forms;

using Emgu.CV;
using Emgu.CV.CvEnum;
using Emgu.CV.Structure;
using Emgu.CV.VideoSurveillance;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// Ʈ
        /// </summary>
        private MCvFont font = new MCvFont(FONT.CV_FONT_HERSHEY_SIMPLEX, 1.0, 1.0);

        /// <summary>
        /// ĸó
        /// </summary>
        private Capture capture;

        /// <summary>
        /// 
        /// </summary>
        private BlobTrackerAuto<Bgr> tracker;

        /// <summary>
        /// 
        /// </summary>
        private IBGFGDetector<Bgr> detector;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainForm()

        /// <summary>
        /// 
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            Run();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region ø̼  óϱ - Application_Idle(sender, e)

        /// <summary>
        /// ø̼  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void Application_Idle(object sender, EventArgs e)
        {
            Image<Bgr, Byte> captureImage = this.capture.QueryFrame();

            captureImage._SmoothGaussian(3);

            this.detector.Update(captureImage);

            Image<Gray, Byte> maskImage = this.detector.ForegroundMask;

            this.tracker.Process(captureImage, maskImage);

            foreach(MCvBlob blob in this.tracker)
            {
                captureImage.Draw((Rectangle)blob, new Bgr(255.0, 255.0, 255.0), 2);

                captureImage.Draw(blob.ID.ToString(), ref this.font, Point.Round(blob.Center), new Bgr(255.0, 255.0, 255.0));
            }

            this.captureImageBox.Image = captureImage;

            this.maskImageBox.Image = maskImage;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region ϱ - Run()

        /// <summary>
        /// ϱ
        /// </summary>
        private void Run()
        {
            try
            {
                this.capture = new Capture();
            }
            catch(Exception exception)
            {
                MessageBox.Show(exception.Message);

                return;
            }
    
            this.detector = new FGDetector<Bgr>(FORGROUND_DETECTOR_TYPE.FGD);

            this.tracker = new BlobTrackerAuto<Bgr>();

            Application.Idle += Application_Idle;
        }

        #endregion
    }
}